/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSEntrySync_h
#define JSEntrySync_h

#if ENABLE(FILE_SYSTEM)

#include "EntrySync.h"
#include "JSDOMBinding.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class JSEntrySync : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSEntrySync* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<EntrySync> impl)
    {
        JSEntrySync* ptr = new (JSC::allocateCell<JSEntrySync>(globalObject->globalData().heap)) JSEntrySync(structure, globalObject, impl);
        ptr->finishCreation(globalObject->globalData());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::ExecState*, JSC::JSGlobalObject*);
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertyDescriptor&);
    static const JSC::ClassInfo s_info;

    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), &s_info);
    }

    static JSC::JSValue getConstructor(JSC::ExecState*, JSC::JSGlobalObject*);
    EntrySync* impl() const { return m_impl.get(); }

private:
    RefPtr<EntrySync> m_impl;
protected:
    JSEntrySync(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<EntrySync>);
    void finishCreation(JSC::JSGlobalData&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, EntrySync*);
EntrySync* toEntrySync(JSC::JSValue);

class JSEntrySyncPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::ExecState*, JSC::JSGlobalObject*);
    static JSEntrySyncPrototype* create(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSEntrySyncPrototype* ptr = new (JSC::allocateCell<JSEntrySyncPrototype>(globalData.heap)) JSEntrySyncPrototype(globalData, globalObject, structure);
        ptr->finishCreation(globalData);
        return ptr;
    }

    static const JSC::ClassInfo s_info;
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier&, JSC::PropertyDescriptor&);
    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), &s_info);
    }

private:
    JSEntrySyncPrototype(JSC::JSGlobalData& globalData, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(globalData, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionGetMetadata(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionMoveTo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionCopyTo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionToURL(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionRemove(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsEntrySyncPrototypeFunctionGetParent(JSC::ExecState*);
// Attributes

JSC::JSValue jsEntrySyncIsFile(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsEntrySyncIsDirectory(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsEntrySyncName(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsEntrySyncFullPath(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsEntrySyncFilesystem(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsEntrySyncConstructor(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);

} // namespace WebCore

#endif // ENABLE(FILE_SYSTEM)

#endif
