/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSMouseEvent_h
#define JSMouseEvent_h

#include "JSUIEvent.h"
#include "MouseEvent.h"
#include <runtime/JSObject.h>

namespace WebCore {

class JSMouseEvent : public JSUIEvent {
public:
    typedef JSUIEvent Base;
    static JSMouseEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<MouseEvent> impl)
    {
        JSMouseEvent* ptr = new (JSC::allocateCell<JSMouseEvent>(globalObject->globalData().heap)) JSMouseEvent(structure, globalObject, impl);
        ptr->finishCreation(globalObject->globalData());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::ExecState*, JSC::JSGlobalObject*);
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertyDescriptor&);
    static const JSC::ClassInfo s_info;

    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), &s_info);
    }

    static JSC::JSValue getConstructor(JSC::ExecState*, JSC::JSGlobalObject*);
protected:
    JSMouseEvent(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<MouseEvent>);
    void finishCreation(JSC::JSGlobalData&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};


class JSMouseEventPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::ExecState*, JSC::JSGlobalObject*);
    static JSMouseEventPrototype* create(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMouseEventPrototype* ptr = new (JSC::allocateCell<JSMouseEventPrototype>(globalData.heap)) JSMouseEventPrototype(globalData, globalObject, structure);
        ptr->finishCreation(globalData);
        return ptr;
    }

    static const JSC::ClassInfo s_info;
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier&, JSC::PropertyDescriptor&);
    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), &s_info);
    }

private:
    JSMouseEventPrototype(JSC::JSGlobalData& globalData, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(globalData, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsMouseEventPrototypeFunctionInitMouseEvent(JSC::ExecState*);
// Attributes

JSC::JSValue jsMouseEventScreenX(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventScreenY(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventClientX(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventClientY(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventCtrlKey(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventShiftKey(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventAltKey(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventMetaKey(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventButton(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventRelatedTarget(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventOffsetX(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventOffsetY(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventX(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventY(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventFromElement(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventToElement(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventDataTransfer(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsMouseEventConstructor(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);

} // namespace WebCore

#endif
